<?php
/**********************************************************************************
* ManageXboxLIVE.php                                                              *
* Version: 0.1 Beta 2                                                             *
***********************************************************************************
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
**********************************************************************************/

// This just avoids some repetition.
function loadXboxLIVESettingParameters($subActions = array(), $defaultAction = '')
{
	global $context, $txt, $sourcedir;

	// You need to be an admin to edit settings!
	isAllowedTo('admin_forum');

	loadLanguage('Help');

	// Will need the utility functions from here.
	require_once($sourcedir . '/ManageServer.php');

	// By default do the basic settings.
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : (!empty($defaultAction) ? $defaultAction : array_pop(array_keys($subActions)));
	$context['sub_action'] = $_REQUEST['sa'];
}

function ManageXboxLIVE()
{
	global $txt, $modSettings, $scripturl, $sourcedir, $context;

	// No Admin? No Access!
	isAllowedTo('admin_forum');

	// Let's give 'em sumthin to talk about!!!
	loadTemplate('ManageXboxLIVE');

	// Our current version
	$context['xbl_version'] = '0.1 Beta 3';

	$context['page_title'] = $txt['smfxbl_admin_info'];

	$subActions = array(
		'info' => 'ManageXboxLIVEInfo',
		'settings' => 'ManageXboxLIVESettings',
		'getdata' => 'getXboxLIVEData',
	);

	loadXboxLIVESettingParameters($subActions, $defaultAction = 'info');

	// By default do the basic settings.
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : (!empty($defaultAction) ? $defaultAction : array_pop(array_keys($subActions)));
	$context['sub_action'] = $_REQUEST['sa'];

	// Load the admin tabs so we know where we are
	$context[$context['admin_menu_name']]['tab_data'] = array(
		'title' => $txt['smfxbl_settings'],
		'description' => $txt['smfxbl_settings_desc'],
		'tabs' => array(
			'info' => array(),
			'settings' => array(),
		),
	);
	// Call the subaction
	$subActions[$_REQUEST['sa']]();

	// Credits!
	$context['smfxbl_credits'] = array(
		array(
			'pretext' => $txt['smfxbl_credits_pretext'],
			'groups' => array(
				array(
					'title' => $txt['smfxbl_credits_dev'],
					'members' => array(
						'vbgamer45',
						'Jason &quot;JBlaze&quot; Clemons',
						'Robbo',
					),
				),
				array(
					'title' => $txt['smfxbl_credits_extras'],
					'members' => array(
						'Mark James for his <a href="http://famfamfam.com/lab/icons/silk">famfamfam Silk Icons</a>',
						'Duncan Mackenzie for his <a href="http://duncanmackenzie.net/blog/put-up-a-rest-api-for-xbox-gamertag-data/default.aspx">XboxLIVE API</a>',
					),
				),
			),
		),
	);
}

function ManageXboxLIVEInfo()
{
	global $context, $sourcedir, $txt, $scripturl;

	// Are we able to be here?
	isAllowedTo('admin_forum');

	$context['page_title'] = $txt['smfxbl_admin_info'];

	// Get a list of admins
	require_once($sourcedir . '/Subs-Membergroups.php');
	if (listMembergroupMembers_Href($context['administrators'], 1, 32) && allowedTo('manage_membergroups'))
	{
		// Add a 'more'-link if there are more than 32.
		$context['more_admins_link'] = '<a href="' . $scripturl . '?action=moderate;area=viewgroups;sa=members;group=1">' . $txt['more'] . '</a>';
	}
}

function ManageXboxLIVESettings($return_config = false)
{
	global $txt, $scripturl, $context, $settings, $sc, $modSettings;

	$context['page_title'] = $txt['smfxbl_admin_settings'];

	$config_vars = array(
		array('int', 'smfxbl_leaderboard_limit'),
	);

	if ($return_config)
		return $config_vars;

	$context['post_url'] = $scripturl . '?action=admin;area=xboxlive;save;sa=settings';
	$context['settings_title'] = $txt['smfxbl_settings'];
	$context['sub_template'] = 'xbl_settings';

	if (empty($config_vars))
	{
		$context['settings_save_dont_show'] = true;
		$context['settings_message'] = '<div class="centertext">' . $txt['modification_no_misc_settings'] . '</div>';

		return prepareDBSettingContext($config_vars);
	}

	if (isset($_GET['save']))
	{
		checkSession();

		$save_vars = $config_vars;
		saveDBSettings($save_vars);
		redirectexit('action=admin;area=xboxlive;sa=settings');
	}
	prepareDBSettingContext($config_vars);
}

// This function is responsible for taking the harvested data and sending it
// to the update function. It is vital to the mod. It also has a pause script
// as to prevent timing out as well as overuse of the API.
/*function getXboxLIVEData()
{
	global $smcFunc, $txt, $sourcedir, $context;

	// Make sure they are an admin... just in case ;)
	isAllowedTo('admin_forum');

	// Now, check their session too!
	checkSession('request');

	// We need this file
	require_once($sourcedir . '/Subs-XboxLIVE.php');

	// Start up the variables for the pause script
	$context['page_title'] =  $txt['not_done_title'];
	$context['continue_countdown'] = '5';
	$context['continue_post_data'] = '';
	$context['continue_get_data'] = '';
	$context['sub_template'] = 'not_done';
	$context['start'] = empty($_REQUEST['start']) ? 0 : (int) $_REQUEST['start'];
	$context['start_time'] =  time();

	// How many players are we updating?
	if (!isset($_REQUEST['total_players']))
	{
		$request = $smcFunc['db_query']('', '
			SELECT COUNT(gamertag)
			FROM {db_prefix}xboxlive',
			array(
			)
		);
		list ($total_players) = $smcFunc['db_fetch_row']($request);
		$smcFunc['db_free_result']($request);
	}
	else
		$total_players = (int) $_REQUEST['total_players'];

	// We gotta lotta work to do...
	if (!empty($total_players))
	{
		while ($context['start'] <= $total_players)
		{
			// Get the id's and stuffs
			$request = $smcFunc['db_query']('', '
				SELECT id_member, gamertag
				FROM {db_prefix}xboxlive
				WHERE last_update <= {int:last_update}
				LIMIT 5',
				array(
					'last_update' => time() - 900,
				)
			);
			$players = array();
			while ($row = $smcFunc['db_fetch_assoc']($request))
				$players[] = $row;
			$smcFunc['db_free_result']($request);

			// We're done if that's the last of em
			if (empty($players))
				redirectexit('action=admin;area=xboxlive;sa=settings;done');

			// Loop through all the players, updating each one
			foreach ($players as $player)
			{
				// Get the gamertag data
				$data = xbl_getGamertagData($player['gamertag']);
				if (!$data)
					continue;

				// Array of all the possible updates
				$update = array(
					'id_member' => $player['id_member'],
					'gamertag' => $player['gamertag'],
					'gamerscore' => $data['player']['gamerscore'],
					'reputation' => round($data['player']['reputation']) / 5, // !!! Fix this to be more accurate?
					'acct_status' => $data['player']['acct_status'],
					'info' => $data['player']['info'],
					'info2' => $data['player']['info2'],
					'last_seen' => $data['player']['last_seen'],
					'online' => $data['player']['online'],
					'title' => $data['player']['title'],
					'zone' => $data['player']['zone'],
					'valid' => $data['player']['valid'],
					'status_text' => $data['player']['status_text'],
					'state' => $data['player']['state'],
					'profile_url' => $data['player']['profile_url'],
					'tile_url' => $data['player']['tile_url'],
					'country' => $data['player']['country'],
					'bio' => $data['player']['bio'],
					'location' => $data['player']['location'],
					'last_update' => time(),
				);
				// Now, update it all!
				xbl_updatePlayer($update, true);
			}

			// Well, we've done at least 5
			$context['start'] += 5;

			// Lets wait a while.
			if (time() - $context['start_time'] > 5)
			{
				// What's the percent?
				$context['continue_percent'] = round(100 * ($context['start'] / $total_players), 1);
				// Can't be more than %100 silly!
				$context['continue_percent'] = min($context['continue_percent'], 100);
				// Again, this damned thing...
				$context['continue_get_data'] = '?action=admin;area=xboxlive;sa=getdata;total_players=' . $total_players . ';start=' . $context['start'] . ';' . $context['session_var'] . '=' . $context['session_id'];
				// Bring it back to teh template
				return;
			}
		}
	}

	// Take me away!
	redirectexit('action=admin;area=xboxlive;sa=settings;done');
}*/

?>