<?php
/**********************************************************************************
* Subs-XboxLIVE.php                                                               *
* Version: 0.1 Beta                                                               *
***********************************************************************************
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
**********************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

// Get a count of all the players and whatnot
function xbl_countPlayers($where, $where_vars = array())
{
	global $smcFunc;

	$request = $smcFunc['db_query']('', '
		SELECT COUNT(*)
		FROM {db_prefix}xboxlive
		WHERE ' . $where,
		array_merge($where_vars, array(
		))
	);
	list ($count) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	return $count;
}

// Get the data from the db so we can make a pretty list
function xbl_listPlayers($start, $items_per_page, $sort, $where, $where_vars = array())
{
	global $smcFunc;

	$request = $smcFunc['db_query']('', '
		SELECT x.id_member, x.gamertag, x.gamerscore, x.reputation, x.status_text,
			x.tile_url, x.zone, x.country, x.location, m.id_member, m.real_name
		FROM {db_prefix}xboxlive AS x
			LEFT JOIN {db_prefix}members AS m ON (m.id_member = x.id_member)
		WHERE ' . $where . '
		ORDER BY {raw:sort}
		LIMIT {int:start}, {int:per_page}',
		array_merge($where_vars, array(
			'sort' => $sort,
			'start' => $start,
			'per_page' => $items_per_page,
		))
	);
	// Wrangle the data into an array
	$data = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$data[] = $row;
	}
	$smcFunc['db_free_result']($request);
	return $data;
}

// Use this to load a given player
function xbl_loadGamertag($mid)
{
	global $smcFunc;

	$request = $smcFunc['db_query']('', '
		SELECT gamertag
		FROM {db_prefix}members
		WHERE id_member = {int:id_member}',
		array('id_member' => $mid)
	);
	$player = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$player[] = $row['gamertag'];
	}
	$smcFunc['db_free_result']($request);
	return $player;
}

// This function is hardcore! It does all the loading of important stuff.
function xbl_loadPlayers($options = array(), $limit = '')
{
	global $smcFunc;

	// All the valid columns
	$validColumns = array(
		'id_member' => 'int',
		'gamertag' => 'string',
		'gamerscore' => 'int',
		'acct_status' => 'string',
		'info' => 'string',
		'info2' => 'string',
		'last_seen' => 'string',
		'online' => 'string',
		'title' => 'string',
		'reputation' => 'int',
		'zone' => 'string',
		'last_played' => 'string',
		'valid' => 'string',
		'status_text' => 'string',
		'state' => 'string',
		'profile_url' => 'string',
		'tile_url' => 'string',
		'country' => 'string',
		'bio' => 'string',
		'location' => 'string',
		'last_update' => 'int',
	);

	// Validation!
	foreach ($options as $col => $value)
	{
		if (!isset($validColumns[$col]))
			unset($options[$col]);
		elseif ($validColumns[$col] == 'int')
			$options[$col] = (int) $value;
	}

	// Onto the query
	$sql = '
		SELECT
			xbl.id_member, xbl.gamertag, xbl.gamerscore, xbl.acct_status,
			xbl.info, xbl.info2, xbl.last_seen, xbl.online, xbl.title, xbl.reputation,
			xbl.zone, xbl.last_played, xbl.valid, xbl.status_text,
			xbl.state, xbl.profile_url, xbl.tile_url, xbl.country, xbl.bio, xbl.location,
			xbl.last_update, mem.id_member, mem.real_name, mem.gamertag
		FROM {db_prefix}xboxlive AS xbl
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = xbl.id_member)';
		isset($limit) ? 'LIMIT ' . $limit : '';

	// Any 'where' options?
	$where = '';
	foreach ($options as $col => $value)
	{
		$where .= 'WHERE xbl.' . $col . ' = {' . $validColumns[$col] . ':' . $col . '}';
	}

	// Now run the query!
	$request = $smcFunc['db_query']('', $sql, $where);

	// Load it into a nice looking array
	$players = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$players[] = $row;
	}
	$smcFunc['db_free_result']($request);
	return $players;
}

// Loads up all the games
/*function xbl_loadGames($options = array())
{
	global $smcFunc;

	// All the valid columns
	$validColumns = array(
		'tid' => 'int',
		'name' => 'string',
		'total_achievements' => 'string',
		'total_gamerscore' => 'string',
		'img_32' => 'string',
		'img_64' => 'string',
	);

	// Validation!
	foreach ($options as $col => $value)
	{
		if (!isset($validColumns[$col]))
			unset($options[$col]);
		elseif ($validColumns[$col] == 'int')
			$options[$col] = (int) $value;
	}

	// Onto the query
	$sql = '
		SELECT
			tid, name, total_achievements, total_gamerscore, img_32, img_64
		FROM {db_prefix}xbox_games';

	// Any 'where' options?
	$where = '';
	foreach ($options as $col => $value)
	{
		$where .= $col . ' = {' . $validColumns[$col] . ':' . $col . '}';
	}

	// Now run the query!
	$request = $smcFunc['db_query']('', $sql, $options);

	// Load it into a nice looking array
	$games = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$games[] = $row;
	}
	$smcFunc['db_free_result']($request);
	return $games;
}*/

// Function to get the total number of rows from a given column
function xbl_getTotalCount($column)
{
	global $smcFunc;

	$request = $smcFunc['db_query']('', '
		SELECT ' . $column . '
		FROM {db_prefix}xboxlive',
		array(
		)
	);
	$num = $smcFunc['db_num_rows']($request);
	$smcFunc['db_free_result']($request);
	return $num;
}

// Simple function to get the total sum of integers in a column
function xbl_getTotalSum($column)
{
	global $smcFunc;

	$request = $smcFunc['db_query']('', '
		SELECT SUM(' . $column . ') AS column_total
		FROM {db_prefix}xboxlive',
		array(
		)
	);
	$sum = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
		$sum = comma_format($row['column_total']);
	$smcFunc['db_free_result']($request);
	return $sum;
}

// Adds a player to the list
function xbl_addPlayer($mid, $gamertag)
{
	global $smcFunc;

	$mid = (int) $mid;
	if (empty($mid) || empty($gamertag))
		return false;

	// No duplicate gamertags!
	if (xbl_loadPlayer($mid) || xbl_loadPlayer($gamertag))
		return false;

	// It passed the test so far. Insert it!
	$smcFunc['db_insert']('insert',
		'{db_prefix}xboxlive',
		array('id_member' => 'int', 'gamertag' => 'string'),
		array($mid, $gamertag),
		array('id_member')
	);

	return true;
}

// Updates a players data
function xbl_updatePlayer($mid, $gamertag)
{
	global $smcFunc;

	// Make sure we have an id AND gamertag
	if (!isset($mid) && !isset($gamertag))
		return false;

	// Call on the API
	$data = xbl_getGamerTagData($gamertag);

	// Update the member
	$smcFunc['db_query']('', '
		UPDATE {db_prefix}xboxlive
		SET
			gamertag = {string:gamertag}, gamerscore = {string:gamerscore}, acct_status = {string:acct_status},
			info = {string:info}, info2 = {string:info2}, last_seen = {string:last_seen}, online = {string:online},
			title = {string:title}, reputation = {string:reputation}, zone = {string:zone}, valid = {string:valid},
			status_text = {string:status_text}, state = {string:state}, profile_url = {string:profile_url}, tile_url = {string:tile_url},
			country = {string:country}, bio = {string:bio}, location = {string:location}, last_update = {int:last_update}
		WHERE id_member = {int:id_member}',
		array(
			'id_member' => $mid, 'gamertag' => $data['gamertag'], 'gamerscore' => $data['gamerscore'], 'acct_status' => $data['acct_status'],
			'info' => $data['info'], 'info2' => $data['info2'], 'last_seen' => $data['last_seen'], 'online' => $data['online'],
			'title' => $data['title'], 'reputation' => $data['reputation'], 'zone' => $data['zone'], 'valid' => $data['valid'],
			'status_text' => $data['status_text'], 'state' => $data['state'], 'profile_url' => $data['profile_url'], 'tile_url' => $data['tile_url'],
			'country' => $data['country'], 'bio' => $data['bio'], 'location' => $data['location'], 'last_update' => time(),
		)
	);

    return true;
}

// Here's where we update the games list
function xbl_updateGames($updates, $ignore_game = false)
{
	global $smcFunc;

	// Do we have a name?
	if (!isset($updates['name']))
		return false;

	// Does the game already exist?
	if (isset($updates['name']) && !$ignore_game)
	{
		$game = xbl_loadGames($updates['name']);
		if ($game && $game['name'] == $updates['name'])
			return false;
	}

	// Now insert them!
	$smcFunc['db_insert']('insert',
		'{db_prefix}xbox_games',
		array('name' => 'string', 'total_achievements' => 'string', 'total_gamerscore' => 'string', 'img_32' => 'string', 'img_64' => 'string'),
		array($updates['name'], $updates['total_achievements'], $updates['total_gamerscore'], $updates['img_32'], $updates['img_64']),
		array('tid')
	);

}

// Now update the last played for players
/*function xbl_updateLastPlayed($updates, $ignore_game = false)
{
	global $smcFunc;

	// Do we have anything to update?
	if (!isset($updates['player']))
		return false;

	// Validation
	$validColumns = array(
		'id_member' => 'int',
		'gamertag' => 'string',
		'name' => 'string',
		'last_played' => 'string',
		'achievements' => 'string',
		'gamerscore' => 'string',
		'compare' => 'string',
	);

	// Strings
	$sql = '';
	foreach ($updates as $col => $value)
		if (isset($validColumns[$col]) && $col != 'id_member')
		{
			$sql .= $col . ' = {' . $validColumns[$col] . ':' . $col . '}, ';

			if ($validColumns[$col] == 'int')
				$updates[$col] = (int) $value;
		}

	// If no, then return false
	if (empty($sql))
		return false;

	// The query!
	$smcFunc['db_qeury']('', '
		UPDATE {db_prefix}xbox_member_games
		SET ' . substr($sql, 0 , strlen($sql) - 2) . '
		WHERE gamertag = {string:gamertag}',
		$updates
	);

	return true;
}*/

// Dude. For real.
function props()
{
	global $context;

	echo'
	<div align="center">
		<span class="smalltext">Powered by <a href="http://www.jblaze.net" title="JBlaze">SMF XboxLIVE ', $context['xbl_version'], '</a></span>
	</div>';
}

// This function returns the raw data from the API
function xbl_getGamertagData($gamertag)
{
	// Get the API, and parse it into a new element
	// !!! This requires PHP5!
	$xml = simplexml_load_file('http://xboxapi.duncanmackenzie.net/gamertag.ashx?GamerTag=' . urlencode($gamertag));

	// Parse out the data...
	$data = array(
		'acct_status' => $xml->AccountStatus,
		'valid' => $xml->PresenceInfo->Valid,
		'info' => $xml->PresenceInfo->Info,
		'info2' => $xml->PresenceInfo->Info2,
		'last_seen' => $xml->PresenceInfo->LastSeen,
		'online' => $xml->PresenceInfo->Online,
		'status_text' => $xml->PresenceInfo->StatusText,
		'title' => $xml->PresenceInfo->Title,
		'state' => $xml->State,
		'gamertag' => $xml->Gamertag,
		'profile_url' => $xml->ProfileUrl,
		'tile_url' => $xml->TileUrl,
		'country' => $xml->Country,
		'reputation' => round($xml->Reputation / 5),
		'bio' => $xml->Bio,
		'location' => $xml->Location,
		'reputation_img' => $xml->ReputationImageUrl,
		'gamerscore' => $xml->GamerScore,
		'zone' => $xml->Zone,
	);

	return $data;
}

?>