<?php
/**********************************************************************************
* XboxLIVE.php                                                                    *
* Version: 0.1 Beta                                                               *
***********************************************************************************
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
**********************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

/*	!!!
*/

// Gets the general data and creates a spiffy list
function XblMain()
{
	global $context, $user_info, $scripturl, $sourcedir, $txt, $settings, $modSettings;

	// The most important part!
	$context['xbl_version'] = '0.1 Beta 2';

	// Make some pretty details
	$context['page_title'] = $context['forum_name'] . ' ' . $txt['smfxbl_title'];
	loadTemplate('XboxLIVE');

	// Make a list of all the stuffs
	require($sourcedir . '/Subs-List.php');

	$listOptions = array(
		'id' => 'xbox_live',
		'title' => $context['forum_name'] . ' ' . $txt['smfxbl_title'],
		'base_href' => $scripturl . '?action=xboxlive',
		'items_per_page' => (!empty($modSettings['smfxbl_leaderboard_limit']) ? $modSettings['smfxbl_leaderboard_limit'] : 20),
		'default_sort_col' => 'gamerscore',
		'default_sort_dir' => 'asc',
		'width' => '',
		'no_items_label' => $txt['smfxbl_no_gamertags'],
		'no_items_align' => 'center',
		'get_items' => array(
			'function' => 'xbl_listPlayers',
			'file' => $sourcedir . '/Subs-XboxLIVE.php',
			'params' => array(
				isset($where) ? $where : '1=1',
				isset($where_vars) ? $where_vars : array(),
			),
		),
		'get_count' => array(
			'function' => 'xbl_countPlayers',
			'file' => $sourcedir . '/Subs-XboxLIVE.php',
			'params' => array(
				isset($where) ? $where : '1=1',
				isset($where_vars) ? $where_vars : array(),
			),
		),
		'columns' => array(
			'member' => array(
				'header' => array(
					'value' => $txt['smfxbl_member'],
				),
				'data' => array(
					'sprintf' => array(
						'format' => '<a href="' . strtr($scripturl, array('%' => '%%')) . '?action=profile;u=%1$d">%2$s</a>',
						'params' => array(
							'id_member' => false,
							'real_name' => false,
						),
					),
					'style' => 'text-align: center',
				),
				'sort' => array(
					'default' => 'real_name',
					'reverse' => 'real_name DESC',
				),
			),
			'gamertag' => array(
				'header' => array(
					'value' => $txt['smfxbl_gamertag'],
				),
				'data' => array(
					'function' => create_function('&$rowData', '
						$gamertag = \'<a href="http://live.xbox.com/member/\' . urlencode($rowData[\'gamertag\']) . \'">\' . $rowData[\'gamertag\'] . \'</a>
										<img class="align_right" src="\' . $rowData[\'tile_url\'] . \'" width="20" height="20" style="border: 1px solid gold;" alt="" />
										<img class="align_right" src="http://avatar.xboxlive.com/avatar/\' . $rowData[\'gamertag\'] . \'/avatarpic-s.png" width="20" height="20" style="border: 1px solid gold;" alt="" />\';
						return $gamertag;
					'),
					'style' => 'text-align: center',
				),
				'sort' => array(
					'default' => 'gamertag',
					'reverse' => 'gamertag DESC',
				),
			),
			'gamerscore' => array(
				'header' => array(
					'value' => $txt['smfxbl_gamerscore'],
				),
				'data' => array(
					'db' => 'gamerscore',
					'style' => 'text-align: center',
				),
				'sort' => array(
					'default' => 'gamerscore',
					'reverse' => 'gamerscore DESC',
				),
			),
			'reputation' => array(
				'header' => array(
					'value' => $txt['smfxbl_reputation'],
				),
				'data' => array(
					'sprintf' => array(
						'format' => '<img src="' . strtr($settings['images_url'], array('%')) . '/xbl/%1$d.png" title="Reputation: %1$d" alt="Reputation: %1$d" />',
						'params' => array(
							'reputation' => false,
						),
					),
					'style' => 'text-align: center',
				),
				'sort' => array(
					'default' => 'reputation',
					'reverse' => 'reputation DESC',
				),
			),
			'status' => array(
				'header' => array(
					'value' => 'Status',
				),
				'data' => array(
					'db' => 'status_text',
					'style' => 'text-align: center',
				),
			),
			'zone' => array(
				'header' => array(
					'value' => 'Zone',
				),
				'data' => array(
					'db' => 'zone',
					'style' => 'text-align: center',
				),
			),
			'country' => array(
				'header' => array(
					'value' => 'Country',
				),
				'data' => array(
					'db' => 'country',
					'style' => 'text-align: center',
				),
			),
			'message' => array(
				'header' => array(
					'value' => $txt['smfxbl_contact'],
				),
				'data' => array(
					'function' => create_function('&$rowData', '
						global $scripturl, $user_info, $context, $txt, $settings;

						$message = \'<a href="http://live.xbox.com/en-US/profile/MessageCenter/SendMessage.aspx?GamerTag=\' . urlencode($rowData[\'gamertag\']) . \'" title="Send Message"><img src="\' . $settings[\'images_url\'] . \'/xbl/email_link.png" alt="Send Message" /></a>
									<a href="http://live.xbox.com/en-US/profile/FriendsMgmt.aspx?GamerTag=\' . urlencode($rowData[\'gamertag\']) . \'" title="Add Friend"><img src="\' . $settings[\'images_url\'] . \'/xbl/group_link.png" alt="Add Friend" /></a>
									\' . (($context[\'user\'][\'is_admin\'] || $user_info[\'id\'] == $rowData[\'id_member\']) ? \'<a href="\' . $scripturl . \'?action=updateplayer;mid=\' . $rowData[\'id_member\'] . \';gtag=\' . urlencode($rowData[\'gamertag\']) . \'"><img src="\' . $settings[\'images_url\'] . \'/xbl/arrow_refresh.png" title="Refresh" alt="" /></a>\' : \'\');

						return $message;
					'),
					'style' => 'text-align: center',
				),
			),
		),
	);

	// Now, the magic!
	createList($listOptions);

	// Now, do some stats and send them to $context
	$context['xbl_total_gamers'] = xbl_getTotalCount('gamertag');
	$context['xbl_total_gamerscore'] = xbl_getTotalSum('gamerscore');
	$context['xbl_average_rep'] = round(xbl_getTotalSum('reputation') / xbl_getTotalCount('gamertag'));
}

// Our fancy little function for updating
function UpdatePlayer()
{
	global $context, $sourcedir, $smcFunc;

	// Are we allowed to update Sir Luke?
	if (!$context['user']['is_admin'])
	{
		if ($context['member']['id'] != $_GET['mid'])
			fatal_lang_error('no_access');
	}

	// Lets find out when they last updated
	$request = $smcFunc['db_query']('', '
		SELECT last_update
		FROM {db_prefix}xboxlive
		WHERE id_member = {int:id_member}',
		array('id_member' => $_GET['mid'])
	);
	list ($updated) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	if (time() - $updated <= 900)
		fatal_lang_error('xbl_wait_time');

	// Call the proper thingy
	require_once($sourcedir . '/Subs-XboxLIVE.php');
	xbl_updatePlayer($_GET['mid'], $_GET['gtag']);

	// Get us outta here!
	redirectexit('action=xboxlive');
}

?>