<?php
/**********************************************************************************
* add_settings.php                                                                *
***********************************************************************************
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
**********************************************************************************/

/*	This file is a simplified database installer. It does what it is suppoed to. */

// List settings here in the format: setting_key => default_value.  Escape any "s. (" => \")
$mod_settings = array();
$mod_settings = array(
	'smfxbl_leaderboard_limit' => 20,
);

// Settings to create the new tables...
$tables = array();
$tables[] = array(
	'table_name' => '{db_prefix}xboxlive',
	'columns' => array(
		array(
			'name' => 'id_member',
			'auto' => false,
			'default' => null,
			'type' => 'mediumint',
			'size' => 8,
			'null' => false,
		),
		array(
			'name' => 'gamertag',
			'auto' => false,
			'default' => null,
			'type' => 'varchar',
			'size' => 15,
			'null' => false,
		),
		array(
			'name' => 'gamerscore',
			'auto' => false,
			'default' => 0,
			'type' => 'varchar',
			'size' => 8,
			'null' => false,
		),
		array(
			'name' => 'acct_status',
			'auto' => false,
			'default' => null,
			'type' => 'tinytext',
			'null' => false,
		),
		array(
			'name' => 'info',
			'auto' => false,
			'default' => null,
			'type' => 'tinytext',
			'null' => false,
		),
		array(
			'name' => 'info2',
			'auto' => false,
			'default' => null,
			'type' => 'tinytext',
			'null' => false,
		),
		array(
			'name' => 'last_seen',
			'auto' => false,
			'default' => null,
			'type' => 'tinytext',
			'null' => false,
		),
		array(
			'name' => 'online',
			'auto' => false,
			'default' => null,
			'type' => 'varchar',
			'size' => 10,
			'null' => false,
		),
		array(
			'name' => 'title',
			'auto' => false,
			'default' => null,
			'type' => 'tinytext',
			'null' => false,
		),
		array(
			'name' => 'reputation',
			'auto' => false,
			'default' => 0,
			'type' => 'mediumint',
			'size' => 8,
			'null' => false,
		),
		array(
			'name' => 'zone',
			'auto' => false,
			'default' => null,
			'type' => 'tinytext',
			'null' => false,
		),
		array(
			'name' => 'last_played',
			'auto' => false,
			'default' => null,
			'type' => 'tinytext',
			'null' => false,
		),
		array(
			'name' => 'valid',
			'auto' => false,
			'default' => null,
			'type' => 'tinytext',
			'null' => false,
		),
		array(
			'name' => 'status_text',
			'auto' => false,
			'default' => null,
			'type' => 'tinytext',
			'null' => false,
		),
		array(
			'name' => 'state',
			'auto' => false,
			'default' => null,
			'type' => 'tinytext',
			'null' => false,
		),
		array(
			'name' => 'profile_url',
			'auto' => false,
			'default' => null,
			'type' => 'tinytext',
			'null' => false,
		),
		array(
			'name' => 'tile_url',
			'auto' => false,
			'default' => null,
			'type' => 'tinytext',
			'null' => false,
		),
		array(
			'name' => 'country',
			'auto' => false,
			'default' => null,
			'type' => 'tinytext',
			'null' => false,
		),
		array(
			'name' => 'bio',
			'auto' => false,
			'default' => null,
			'type' => 'text',
			'null' => false,
		),
		array(
			'name' => 'location',
			'auto' => false,
			'default' => null,
			'type' => 'tinytext',
			'null' => false,
		),
		array(
			'name' => 'last_update',
			'auto' => false,
			'default' => 0,
			'type' => 'int',
			'size' => 20,
			'null' => false,
		),
	),
	'indexes' => array(
		array(
			'columns' => array('id_member'),
			'type' => 'PRIMARY',
			'name' => 'id_member',
		),
	),
	'if_exists' => 'update',
	'error' => 'fatal',
	'parameters' => array(),
);

$rows = array();

$columns = array();
$columns[] = array(
	'table_name' => '{db_prefix}members',
	'column_info' => array(
		'name' => 'gamertag',
		'type' => 'varchar',
		'size' => 15,
		'null' => false,
		'default' => '',
	),
	'error' => 'fatal',
);

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
{
	require_once(dirname(__FILE__) . '/SSI.php');
}
elseif(!defined('SMF'))
{
	die('<b>Error:</b> Cannot install - please verify you put this file in the same place as SMF\'s SSI.php.');
}

	updateSettings($mod_settings);

	db_extend('packages');
	foreach ($tables as $table)
		$smcFunc['db_create_table']($table['table_name'], $table['columns'], $table['indexes'], $table['parameters'], $table['if_exists'], $table['error']);

	foreach ($rows as $row)
		$smcFunc['db_insert']($row['method'], $row['table_name'], $row['columns'], $row['data'], $row['keys']);

	foreach ($columns as $column)
		$smcFunc['db_add_column']($column['table_name'], $column['column_info'], $column['parameters'], $column['if_exists'], $column['error']);

if (SMF == 'SSI')
	echo 'Congratulations! You have successfully installed SMF XboxLIVE!';

?>